Subject: Re: [PATCH net-next 12/13] genetlink: allow families to use split ops directly

From: Jakub Kicinski <[email-masked]>
Date: Fri, 21 Oct 2022 08:01:13 -0700

On Fri, 21 Oct 2022 13:02:31 +0200 Johannes Berg wrote:
> > Perhaps we could hang it of the .resv_start_op as well?  
> 
> Yes, hopefully? Maybe?
> 
> > Any op past that would treat policy == NULL as reject all?  
> 
> Right. The only danger is that someone already added new stuff somewhere
> and bad/broken userspace already used it with garbage attrs.
> 
> But the chances of that are probably low.
> 
> So I'd say go for it, and worst case we bump up the resv_start_op for
> anything that breaks? Wouldn't be a huge loss either.

resv_start_op are only present in -rc kernels, so I think we can break
things risking only common anger not uAPI wrath :)

> > We'd need to add GENL_DONT_VALIDATE_DO for families which 
> > want to parse inside the callbacks. I wonder if people would
> > get annoyed.  
> 
> Why would anyone really want to _parse_ in the callbacks?

Until recently that was the only way to do per-op policies, I don't
know if anyone actually used per-op policies outside of ethtool tho.